<template>
  <div>
    <BasicTable @register="registerTable">
      <template #bodyCell="{ column, record }">
        <template v-if="column.key === 'master'">
          <Tag :color="record.master ? 'error' : 'success'">
            {{ commonDict(record.master, 0) }}
          </Tag>
        </template>
        <template v-if="column.key === 'type'">
          <span v-if="record.type == 'ali'">阿里云</span>
          <span v-else-if="record.type == 'db'">数据库</span>
          <span v-else-if="record.type == 'local'">本地存储</span>
          <span v-else-if="record.type == 'minio'">minio存储</span>
        </template>

        <template v-if="column.key === 'action'">
          <TableAction
            :actions="[
              // {
              //   tooltip: '文件上传',
              //   label: '文件上传',
              //   onClick: handleUpdateModel.bind(null, record),
              // },
              {
                auth: 'storage:config:query',
                icon: 'icon-eye|iconfont',
                tooltip: '查看',
                label: '查看',
                onClick: handleView.bind(null, record),
              },
              {
                auth: 'storage:config:edit',
                icon: 'icon-edit|iconfont',
                tooltip: '编辑',
                label: '编辑',
                onClick: handleEdit.bind(null, record),
              },
            ]"
            :dropDownActions="[
              {
                auth: 'storage:config:edit',
                tooltip: '主配置',
                label: '主配置',
                ifShow: !record.master,
                popConfirm: {
                  title: '是否确认设置为主配置',
                  placement: 'left',
                  confirm: handleMaster.bind(null, record),
                },
              },
              {
                auth: 'storage:config:remove',
                icon: 'icon-delete|iconfont',
                tooltip: '删除',
                label: '删除',
                color: 'error',
                popConfirm: {
                  title: '是否确定要删除此配置？',
                  placement: 'left',
                  confirm: handleDelete.bind(null, record),
                },
              },
            ]"
          />
        </template>
      </template>
      <template #toolbar>
        <Button
          v-auth="['storage:config:add']"
          type="primary"
          @click="handleCreate"
          preIcon="icon-plus|iconfont"
        >
          新增
        </Button>
        <Button
          v-auth="['storage:config:remove']"
          type="primary"
          danger
          @click="handleDelete(null)"
          preIcon="icon-delete|iconfont"
        >
          批量删除
        </Button>
      </template>
    </BasicTable>
    <FormDrawer @register="registerDrawer" @success="handleSuccess" />
    <ViewDrawer @register="registerDrawerView" @success="handleSuccess" />
    <!-- <UploadModal @register="registerUpload" /> -->
  </div>
</template>
<script lang="ts" setup>
  import { Tag } from 'ant-design-vue';
  import { onBeforeMount, ref } from 'vue';
  import { Button } from '/@/components/Button';

  import { BasicTable, useTable, TableAction } from '/@/components/Table';
  // import UploadModal from './uploadModel.vue';
  import { useMessage } from '/@/hooks/web/useMessage';
  import FormDrawer from './formDrawer.vue';
  import ViewDrawer from './viewDrawer.vue';
  import { columns, searchFormSchema } from './data';

  import {
    infraStorageconfigQueryPage,
    infraStorageconfigRemove,
    infraStorageconfigMaster,
  } from '/@/api/infra/infraStorageConfigApi';
  import { useDrawer } from '/@/components/Drawer';
  import { commonDict } from '/@/utils';
  // import { useModal } from '/@/components/Modal';

  onBeforeMount(async () => {});

  const { createConfirm, createMessage } = useMessage();
  // const [registerModal, { openModal }] = useModal();
  const [registerDrawer, { openDrawer }] = useDrawer();
  const [registerDrawerView, { openDrawer: openDrawerView }] = useDrawer();
  // const [registerUpload, { openModal: openUpload }] = useModal();
  const tableSort = ref([
    {
      field: 'master',
      direction: 'DESC',
    },
    {
      field: 'create_time',
      direction: 'DESC',
    },
  ]) as any;

  const [registerTable, { reload, getSelectRowKeys, clearSelectedRowKeys }] = useTable({
    title: '文件存储配置 ',
    api: infraStorageconfigQueryPage,
    rowKey: 'id',
    columns,
    showIndexColumn: true,
    rowSelection: { type: 'checkbox' },
    formConfig: {
      labelWidth: 120,
      schemas: searchFormSchema,
      autoSubmitOnEnter: true,
      baseColProps: { xs: 24, sm: 12, md: 12, lg: 8 },
      resetButtonOptions: {
        preIcon: 'icon-delete|iconfont',
      },
      submitButtonOptions: {
        preIcon: 'icon-search|iconfont',
      },
    },
    useSearchForm: true,
    bordered: true,
    actionColumn: {
      width: 260,
      title: '操作',
      dataIndex: 'action',
    },
    beforeFetch: handleBeforeFetch,
    sortFn: handleSortFn,
  });
  // 详情按钮事件
  function handleView(record: Recordable) {
    console.log(record);
    openDrawerView(true, {
      record,
    });
  }

  // 新增按钮事件
  function handleCreate() {
    openDrawer(true, {
      isUpdate: false,
    });
  }

  // 编辑按钮事件
  function handleEdit(record: Recordable) {
    openDrawer(true, {
      record,
      isUpdate: true,
    });
  }

  // 删除按钮事件
  async function handleDelete(record: Recordable) {
    if (record) {
      await infraStorageconfigRemove([record.id]);
      createMessage.success('删除成功！');
      await reload();
    } else {
      const keys = getSelectRowKeys();
      if (keys.length > 0) {
        createConfirm({
          content: '你确定要删除?',
          iconType: 'warning',
          onOk: async () => {
            const keys = getSelectRowKeys();
            await infraStorageconfigRemove(keys);
            createMessage.success('删除成功！');
            await reload();
            clearSelectedRowKeys();
          },
        });
      } else {
        createMessage.warning('请选择要删除的数据');
      }
    }
  }
  // 设置主配置
  async function handleMaster(record: Recordable) {
    if (record) {
      await infraStorageconfigMaster(record.id);
      createMessage.success('设置为主配置成功！');
      await reload();
    }
  }

  // 打开上传测试弹窗
  // function handleUpdateModel(record: Recordable) {
  //   openUpload(true, { record });
  // }
  // 表格点击字段排序
  function handleSortFn(sortInfo) {
    if (sortInfo?.order && sortInfo?.columnKey) {
      // 默认单列排序
      tableSort.value = [
        {
          field: sortInfo.columnKey,
          direction: sortInfo.order.replace(/(\w+)(end)/g, '$1').toUpperCase(),
        },
      ];
    }
  }

  // 表格请求之前，对参数进行处理, 添加默认 排序
  function handleBeforeFetch(params) {
    return { ...params, orders: tableSort.value };
  }

  // 弹窗回调事件
  async function handleSuccess({ isUpdate, values }) {
    console.log(isUpdate);
    console.log(values);
    await reload();
  }
</script>
